## com.google.gwt.user.client.ui
Class TextBoxBase

    java.lang.Object
      com.google.gwt.user.client.ui.UIObject
          com.google.gwt.user.client.ui.Widget
              com.google.gwt.user.client.ui.FocusWidget
                  com.google.gwt.user.client.ui.TextBoxBase

All Implemented Interfaces:
  HasAllFocusHandlers, HasAllKeyHandlers, HasAllMouseHandlers, HasBlurHandlers, HasChangeHandlers, HasClickHandlers, HasFocusHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasValueChangeHandlers<java.lang.String>, HasHandlers, EventListener, Focusable, HasFocus, HasName, HasText, HasValue<java.lang.String>, SourcesChangeEvents, SourcesClickEvents, SourcesFocusEvents, SourcesKeyboardEvents, SourcesMouseEvents

Direct Known Subclasses:
  TextArea, TextBox

    public class TextBoxBase

extends FocusWidget
implements SourcesChangeEvents, HasChangeHandlers, HasText, HasName, HasValue<java.lang.String>

Abstract base class for all text entry widgets.

Nested Class Summary
`static class` | `TextBoxBase.TextAlignConstant` Text alignment constant, used in `setTextAlignment(TextBoxBase.TextAlignConstant)`.

Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject
`UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

Field Summary
`static TextBoxBase.TextAlignConstant` | `ALIGN_CENTER` Center the text.
`static TextBoxBase.TextAlignConstant` | `ALIGN_JUSTIFY` Justify the text.
`static TextBoxBase.TextAlignConstant` | `ALIGN_LEFT` Align the text to the left edge.
`static TextBoxBase.TextAlignConstant` | `ALIGN_RIGHT` Align the text to the right.

Fields inherited from class com.google.gwt.user.client.ui.UIObject
`DEBUG_ID_PREFIX`

Constructor Summary
`protected` | `TextBoxBase(Element elem)` Creates a text box that wraps the given browser element handle.

Method Summary
`HandlerRegistration` | `addChangeHandler(ChangeHandler handler)` Adds a `ChangeEvent` handler.
`void` | `addChangeListener(ChangeListener listener)` Deprecated. Use `addChangeHandler` instead
`HandlerRegistration` | `addValueChangeHandler(ValueChangeHandler<java.lang.String> handler)` Adds a `ValueChangeEvent` handler.
`void` | `cancelKey()` If a keyboard event is currently being handled on this text box, calling this method will suppress it.
`int` | `getCursorPos()` Gets the current position of the cursor (this also serves as the beginning of the text selection).
`protected com.google.gwt.user.client.ui.impl.TextBoxImpl` | `getImpl()`
`java.lang.String` | `getName()` Gets the widget's name.
`java.lang.String` | `getSelectedText()` Gets the text currently selected within this text box.
`int` | `getSelectionLength()` Gets the length of the current text selection.
`java.lang.String` | `getText()` Gets this object's text.
`java.lang.String` | `getValue()` Gets this object's value.
`boolean` | `isReadOnly()` Determines whether or not the widget is read-only.
`void` | `onBrowserEvent(Event event)` Fired whenever a browser event is received.
`void` | `removeChangeListener(ChangeListener listener)` Deprecated. Use the `HandlerRegistration.removeHandler()` method on the object returned by `addChangeHandler(com.google.gwt.event.dom.client.ChangeHandler)` instead
`void` | `selectAll()` Selects all of the text in the box.
`void` | `setCursorPos(int pos)` Sets the cursor position.
`void` | `setKey(char key)` Deprecated. this method only works in IE and should not have been added to the API
`void` | `setName(java.lang.String name)` Sets the widget's name.
`void` | `setReadOnly(boolean readOnly)` Turns read-only mode on or off.
`void` | `setSelectionRange(int pos, int length)` Sets the range of text to be selected.
`void` | `setText(java.lang.String text)` Sets this object's text.
`void` | `setTextAlignment(TextBoxBase.TextAlignConstant align)` Sets the alignment of the text in the text box.
`void` | `setValue(java.lang.String value)` Sets this object's value without firing any events.
`void` | `setValue(java.lang.String value, boolean fireEvents)` Sets this object's value.

Methods inherited from class com.google.gwt.user.client.ui.FocusWidget

`addBlurHandler, addClickHandler, addClickListener, addFocusHandler, addFocusListener, addKeyboardListener, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addMouseDownHandler, addMouseListener, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMouseWheelHandler, addMouseWheelListener, getFocusImpl, getTabIndex, isEnabled, removeClickListener, removeFocusListener, removeKeyboardListener, removeMouseListener, removeMouseWheelListener, setAccessKey, setElement, setEnabled, setFocus, setTabIndex`

Methods inherited from class com.google.gwt.user.client.ui.Widget
`addDomHandler, addHandler, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getHandlerCount, getParent, isAttached, isOrWasAttached, onAttach, onDetach, onLoad, onUnload, removeFromParent, sinkEvents`

Methods inherited from class com.google.gwt.user.client.ui.UIObject

`addStyleDependentName, addStyleName, ensureDebugId, ensureDebugId, ensureDebugId, getAbsoluteLeft, getAbsoluteTop, getElement, getOffsetHeight, getOffsetWidth, getStyleElement, getStyleName, getStyleName, getStylePrimaryName, getStylePrimaryName, getTitle, isVisible, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, setElement, setHeight, setPixelSize, setSize, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setTitle, setVisible, setVisible, setWidth, toString, unsinkEvents`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### ALIGN_CENTER

    public static final TextBoxBase.TextAlignConstant ALIGN_CENTER

  Center the text.

### ALIGN_JUSTIFY

    public static final TextBoxBase.TextAlignConstant ALIGN_JUSTIFY

  Justify the text.

### ALIGN_LEFT

    public static final TextBoxBase.TextAlignConstant ALIGN_LEFT

  Align the text to the left edge.

### ALIGN_RIGHT

    public static final TextBoxBase.TextAlignConstant ALIGN_RIGHT

  Align the text to the right.

Constructor Detail

### TextBoxBase

    protected TextBoxBase(Element elem)

  Creates a text box that wraps the given browser element handle. This is only used by subclasses.

  Parameters:
    `elem` - the browser element to wrap

Method Detail

### addChangeHandler

    public HandlerRegistration addChangeHandler(ChangeHandler handler)

  Description copied from interface: `HasChangeHandlers`
  Adds a `ChangeEvent` handler.

  Specified by:
    `addChangeHandler` in interface `HasChangeHandlers`
  Parameters:
    `handler` - the change handler
  Returns:
    `HandlerRegistration` used to remove this handler

### addChangeListener

    @Deprecated
    public void addChangeListener(ChangeListener listener)

  Deprecated. Use `addChangeHandler` instead

  Description copied from interface: `SourcesChangeEvents`
  Adds a listener interface to receive change events.

  Specified by:
    `addChangeListener` in interface `SourcesChangeEvents`
  Parameters:
    `listener` - the listener interface to add

### addValueChangeHandler

    public HandlerRegistration addValueChangeHandler(ValueChangeHandler<java.lang.String> handler)

  Description copied from interface: `HasValueChangeHandlers`
  Adds a `ValueChangeEvent` handler.

  Specified by:
    `addValueChangeHandler` in interface `HasValueChangeHandlers<java.lang.String>`
  Parameters:
    `handler` - the handler
  Returns:
    the registration for the event

### cancelKey

    public void cancelKey()

  If a keyboard event is currently being handled on this text box, calling this method will suppress it. This allows listeners to easily filter keyboard input.

### getCursorPos

    public int getCursorPos()

  Gets the current position of the cursor (this also serves as the beginning of the text selection).

  Returns:
    the cursor's position

### getName

    public java.lang.String getName()

  Description copied from interface: `HasName`
  Gets the widget's name.

  Specified by:
    `getName` in interface `HasName`
  Returns:
    the widget's name

### getSelectedText

    public java.lang.String getSelectedText()

  Gets the text currently selected within this text box.

  Returns:
    the selected text, or an empty string if none is selected

### getSelectionLength

    public int getSelectionLength()

  Gets the length of the current text selection.

  Returns:
    the text selection length

### getText

    public java.lang.String getText()

  Description copied from interface: `HasText`
  Gets this object's text.

  Specified by:
    `getText` in interface `HasText`
  Returns:
    the object's text

### getValue

    public java.lang.String getValue()

  Description copied from interface: `HasValue`
  Gets this object's value.

  Specified by:
    `getValue` in interface `HasValue<java.lang.String>`
  Returns:
    the object's value

### isReadOnly

    public boolean isReadOnly()

  Determines whether or not the widget is read-only.

  Returns:
    `true` if the widget is currently read-only, `false` if the widget is currently editable

### onBrowserEvent

    public void onBrowserEvent(Event event)

  Description copied from interface: `EventListener`
  Fired whenever a browser event is received.

  Specified by:
    `onBrowserEvent` in interface `EventListener`
  Overrides:
    `onBrowserEvent` in class `Widget`
  Parameters:
    `event` - the event received

### removeChangeListener

    @Deprecated
    public void removeChangeListener(ChangeListener listener)

  Deprecated. Use the `HandlerRegistration.removeHandler()` method on the object returned by `addChangeHandler(com.google.gwt.event.dom.client.ChangeHandler)` instead

  Description copied from interface: `SourcesChangeEvents`
  Removes a previously added listener interface.

  Specified by:
    `removeChangeListener` in interface `SourcesChangeEvents`
  Parameters:
    `listener` - the listener interface to remove

### selectAll

    public void selectAll()

  Selects all of the text in the box. This will only work when the widget is attached to the document and not hidden.

### setCursorPos

    public void setCursorPos(int pos)

  Sets the cursor position. This will only work when the widget is attached to the document and not hidden.

  Parameters:
    `pos` - the new cursor position

### setKey

    @Deprecated
    public void setKey(char key)

  Deprecated. this method only works in IE and should not have been added to the API

  If a keyboard event is currently being handled by the text box, this method replaces the unicode character or key code associated with it. This allows listeners to easily filter keyboard input.

  Parameters:
    `key` - the new key value

### setName

    public void setName(java.lang.String name)

  Description copied from interface: `HasName`
  Sets the widget's name.

  Specified by:
    `setName` in interface `HasName`
  Parameters:
    `name` - the widget's new name

### setReadOnly

    public void setReadOnly(boolean readOnly)

  Turns read-only mode on or off.

  Parameters:
    `readOnly` - if `true`, the widget becomes read-only; if `false` the widget becomes editable

### setSelectionRange

    public void setSelectionRange(int pos,
                                  int length)

  Sets the range of text to be selected. This will only work when the widget is attached to the document and not hidden.

  Parameters:
    `pos` - the position of the first character to be selected
    `length` - the number of characters to be selected

### setText

    public void setText(java.lang.String text)

  Description copied from interface: `HasText`
  Sets this object's text.

  Specified by:
    `setText` in interface `HasText`
  Parameters:
    `text` - the object's new text

### setTextAlignment

    public void setTextAlignment(TextBoxBase.TextAlignConstant align)

  Sets the alignment of the text in the text box.

  Parameters:
    `align` - the text alignment (as specified by `ALIGN_CENTER`, `ALIGN_JUSTIFY`, `ALIGN_LEFT`, and `ALIGN_RIGHT`)

### setValue

    public void setValue(java.lang.String value)

  Description copied from interface: `HasValue`
  Sets this object's value without firing any events. This should be identical to calling setValue(value, false).

  It is acceptable to fail assertions or throw (documented) unchecked exceptions in response to bad values.

  By convention, GWT widgets that can be cleared accept null for `value`, but it is acceptable for widgets that cannot be cleared to throw an exception for null values.

  Specified by:
    `setValue` in interface `HasValue<java.lang.String>`
  Parameters:
    `value` - the object's new value

### setValue

    public void setValue(java.lang.String value,
                         boolean fireEvents)

  Description copied from interface: `HasValue`
  Sets this object's value. Fires `ValueChangeEvent` when fireEvents is true and the new value does not equal the existing value.

  It is acceptable to fail assertions or throw (documented) unchecked exceptions in response to bad values.

  Specified by:
    `setValue` in interface `HasValue<java.lang.String>`
  Parameters:
    `value` - the object's new value
    `fireEvents` - fire events if true and value is new

### getImpl

    protected com.google.gwt.user.client.ui.impl.TextBoxImpl getImpl()